import { lobbyMessage } from "../Classes/lobbyMessage";
import { playerData } from "../Classes/playerData"
import { playerInventory } from "../Classes/playerInventory";
import { userData } from "../Classes/userData";
import { game } from "../game";

export function registerLobbyCallbacks(socket){
    socket.on('lobby/playerJoin', (data) => {
        if(!socket.hasOwnProperty("user")) return;

        let buff = Buffer.from(data, 'base64');
        let data1 : playerData = JSON.parse(buff.toString('utf-8'));

        let pd = new playerData()
        pd.socketId = socket.id
        pd.userName = socket.user.login
        pd.characterId = data1.characterId;
        pd.inventory = data1.inventory;
        socket.user.playerData = pd

        game.lobbyState.players.push(socket.user.playerData)
        game.socketIO.emit("lobby/playerJoin", JSON.stringify(game.lobbyState))
        socket.emit('lobby/messages', JSON.stringify(game.messages))
    });

    socket.on('lobby/playerUpdate', (data) => {
        if(!socket.hasOwnProperty("user")) return;

        let buff = Buffer.from(data, 'base64');
        let data1 : playerData = JSON.parse(buff.toString('utf-8'));
        data1.socketId = socket.id

        let idx = game.lobbyState.players.findIndex((pl) => pl.socketId == socket.id)
        if(idx == -1){
            console.log("Error! Player not spawned!")
        }
        else{
            game.lobbyState.players[idx].rigidbody = data1.rigidbody
        }
    });

    socket.on('lobby/lobbyUpdate', (data) => {
        if(!socket.hasOwnProperty("user")) return;

        let buff = Buffer.from(data, 'base64');
        let data1 = JSON.parse(buff.toString('utf-8'));

        game.lobbyState.objects = data1.objects
    });

    socket.on('lobby/loadoutChanged', (data) => {
        if(!socket.hasOwnProperty("user")) return;

        let buff = Buffer.from(data, 'base64');
        let data1 : playerData = JSON.parse(buff.toString('utf-8'));

        socket.user.playerData.inventory = data1.inventory
        playerInventory.validate(socket.user.playerData.inventory)

        game.socketIO.emit("lobby/loadoutChanged", JSON.stringify(socket.user.playerData))
    });

    socket.on('lobby/message', (data) => {
        if(!socket.hasOwnProperty("user")) return;

        let buff = Buffer.from(data, 'base64');
        let data1 : lobbyMessage = JSON.parse(buff.toString('utf-8'));
        data1.timestamp = new Date().toLocaleString();

        game.addMessage(data1)
    });
}